import * as wpj from '../support/wpj';

describe('Výběr filtrů', () => {
   it('Přechod do filtrovatelné sekce', () => {
      cy.visit('/');
      cy.get('.c-header-sections ul li a').contains('Káva').click();
      cy.url().should('contain', '/kava_k451/');

      cy.matchImageSnapshot('Sekce Káva{id=451}');
   });

   it('Kontrola výchozího počtu produktů', () => {
      cy.get('.filter-total').should('contain', 6);
   });

   it('Kliknuti na filtr vyrobci', () => {
      cy.get('.filter-top-horizontal > .filter-item:not(.filter-item-more)').last().click();
   });

   it('Vybrani vyrobce Beansmith\'s', () => {
      cy.get('[for="mc-beansmith\'s-124"]').click();
      cy.get('.reset-item').contains('Beansmith\'s');
      cy.url().should('include', 'dynamic_filter%5BproducerIds%5D%5B0%5D=124');
      cy.get('.filter-total').should('contain', 2);

      cy.matchImageSnapshot('Sekce Káva filtrováno podle výrobce Beansmith\'s');
   });

   it('Vyber dalsiho filtru vyrobce Nordbeans', () => {
      cy.get('[for="mc-nordbeans-125"]').click();
      cy.get('.reset-item').contains('Nordbeans');
      cy.url().should('include', 'dynamic_filter%5BproducerIds%5D%5B1%5D=125');
      cy.get('.filter-total').should('contain', 6);

      cy.matchImageSnapshot('Sekce Káva filtrováno podle výrobců Rafiki a wpj');
   });

   it('Reset filtru', () => {
      cy.get('.reset-all').click();
      cy.url().should('not.include', 'producerIds');
   });

   it('Výběr řazení "Nejlevnější"', () => {
      cy.get('[name="order"]').select('Nejlevnější');
      cy.url().should('include', 'order=price');

      cy.matchImageSnapshot('Sekce Káva řazeno podle nejlevnějších produktů');
   });

   it('Výběr prvního produktu v aktivním filtru', () => {
      wpj.getNthProduct(0).find('.product-link').first().click();
      cy.get('.c-breadcrumbs .active').contains('Hacienda Sonora, 250g');
   });

   it('Výběr filtru "Nejdražší"', () => {
      cy.get('.c-breadcrumbs  li:nth-child(2) > a').click();
      cy.get('.c-breadcrumbs .active').contains('Káva');
      cy.get('[name="order"]').select('Nejdražší');
      cy.url().should('include', 'order');

      cy.matchImageSnapshot('Sekce Káva řazeno podle nejdražších produktů');
   });

   it('Výběr prvního produktu v aktivním filtru', () => {
      wpj.getNthProduct(0).find('.product-link').first().click();
      cy.get('.c-breadcrumbs .active').contains('Předplatné Espresso 1000g');
   });
});
